package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.WFStepDataMapper;
import com.sa.ibiz.demo.demo.domain.WFStepData;
import com.sa.ibiz.demo.demo.service.WFStepDataService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.WFStepDataSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.WFInstanceService;
import com.sa.ibiz.demo.demo.service.WFStepService;
import com.sa.ibiz.demo.demo.service.WFUserService;

/**
 * 实体[WFStepData] 服务对象接口实现
 */
@Service
public class WFStepDataServiceImpl extends ServiceImplBase<WFStepDataMapper, WFStepData> implements WFStepDataService{

    @Autowired
    private WFInstanceService wfinstanceService;
    @Autowired
    private WFStepService wfstepService;
    @Autowired
    private WFUserService originalwfuserService;

    @Resource
    private WFStepDataMapper wfstepdataMapper;


    @Override
    public boolean create(WFStepData et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(WFStepData et){
        this.beforeUpdate(et);
		this.wfstepdataMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(WFStepData et){
		return et.getWfstepdataid();  
    }

    @Override
    public boolean getDraft(WFStepData et)  {
    if((!StringUtils.isEmpty(et.getWfinstanceid())) && et.getWfinstance() == null){
            try {
                et.setWfinstance(wfinstanceService.getById(et.getWfinstanceid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getWfstepid())) && et.getWfstep() == null){
            try {
                et.setWfstep(wfstepService.getById(et.getWfstepid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getOriginalwfuserid())) && et.getOriginalwfuser() == null){
            try {
                et.setOriginalwfuser(originalwfuserService.getById(et.getOriginalwfuserid()));
            }catch (Exception ex){}
        }
            return true;
    }
    @Override
    public WFStepData rollback(WFStepData et)  {
		return et;
    }

	public List<WFStepData> listDefault(WFStepDataSearchFilter filter) {
		return wfstepdataMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<WFStepData> searchDefault(WFStepDataSearchFilter filter) {
		return wfstepdataMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}


	public List<WFStepData> listMyHist(WFStepDataSearchFilter filter) {
		return wfstepdataMapper.searchMyHist(filter,filter.getSelectCond());
	}

	public Page<WFStepData> searchMyHist(WFStepDataSearchFilter filter) {
		return wfstepdataMapper.searchMyHist(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return wfstepdataMapper.selectRow(sql);
    }

 }